/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.JenisPegawaiDto;
import com.portofolio.service.JenisPegawaiService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;


@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/jenisPegawai")
public class JenisPegawaiController extends LocaleController {
    @Lazy
	@Autowired
    private JenisPegawaiService jenisPegawaiService;
    
    
    @ApiOperation("Api Untuk Menyimpan JenisPegawai")
    @PostMapping("/save")
    public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody JenisPegawaiDto entity,HttpServletRequest request) {
        Map<String, Object> result = jenisPegawaiService.save(entity);
        return RestUtil.getJsonResponse(result);
    }
    
    @ApiOperation("Api Untuk Update JenisPegawai")
    @PutMapping("/update")
    public ResponseEntity<Map<String, Object>> update(
    		@RequestParam(value = "kdJenisPegawai", required = true) String kdJenisPegawai,
    		@RequestParam(value = "version", required = true) Integer version,
    		@Valid @RequestBody JenisPegawaiDto entity, HttpServletRequest request) {
        Map<String, Object> result = jenisPegawaiService.update(entity,kdJenisPegawai,version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menghapus JenisPegawai Berdasarkan KdJenisPegawai")
    @DeleteMapping("/delete")
    public ResponseEntity<Map<String, Object>> deleteById(
    		@RequestParam(value = "kdJenisPegawai", required = true) String kdJenisPegawai,
    		@RequestParam(value = "version", required = true) Integer version
    		) {
        Map<String, Object> result = jenisPegawaiService.deleteById(kdJenisPegawai, version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Semua JenisPegawai")
    @GetMapping("/grid")
    public ResponseEntity<Map<String, Object>> grid(
    		@RequestParam(value = "page", defaultValue = "1") Integer page, 
    		@RequestParam(value = "rows", defaultValue = "10") Integer rows,			
    		@RequestParam(value = "dir", defaultValue = "namaJenisPegawai") String dir,			
    		@RequestParam(value = "sort", defaultValue = "desc") String sort,			
    		@RequestParam(value = "namaJenisPegawai", required = false) String namaJenisPegawai,
    		@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
        Map<String, Object> result = jenisPegawaiService.grid(page, rows, sort, dir, namaJenisPegawai,statusEnabled);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan JenisPegawai Berdasarkan kdJenisPegawai")
    @GetMapping("/findByKdJenisPegawai")
    public ResponseEntity<Map<String, Object>> findByKdJenisPegawai(
    		@RequestParam(value = "kdJenisPegawai", required = true) String kdJenisPegawai, 
    		HttpServletRequest request) {
        Map<String, Object> result = jenisPegawaiService.findByKdJenisPegawai(kdJenisPegawai);
        return RestUtil.getJsonResponse(result);
    }


}
